Index: gnu/usr.bin/perl/plan9/config.plan9
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/plan9/config.plan9,v
retrieving revision 1.21
diff -u -p -u -p -r1.21 config.plan9
--- gnu/usr.bin/perl/plan9/config.plan9	13 Feb 2019 21:15:28 -0000	1.21
+++ gnu/usr.bin/perl/plan9/config.plan9	13 May 2019 15:13:25 -0000
@@ -3142,8 +3142,8 @@
  *	This symbol contains the ~name expanded version of PRIVLIB, to be used
  *	in programs that are not prepared to deal with ~ expansion at run-time.
  */
-#define PRIVLIB "/sys/lib/perl/5.28.1"		/**/
-#define PRIVLIB_EXP "/sys/lib/perl/5.28.1"		/**/
+#define PRIVLIB "/sys/lib/perl/5.28.2"		/**/
+#define PRIVLIB_EXP "/sys/lib/perl/5.28.2"		/**/
 
 /* PTRSIZE:
  *	This symbol contains the size of a pointer, so that the C preprocessor
@@ -3270,9 +3270,9 @@
  *	removed.  The elements in inc_version_list (inc_version_list.U) can
  *	be tacked onto this variable to generate a list of directories to search.
  */
-#define SITELIB "/sys/lib/perl/5.28.1/site_perl"		/**/
-#define SITELIB_EXP "/sys/lib/perl/5.28.1/site_perl"		/**/
-#define SITELIB_STEM "/sys/lib/perl/5.28.1/site_perl"		/**/
+#define SITELIB "/sys/lib/perl/5.28.2/site_perl"		/**/
+#define SITELIB_EXP "/sys/lib/perl/5.28.2/site_perl"		/**/
+#define SITELIB_STEM "/sys/lib/perl/5.28.2/site_perl"		/**/
 
 /* Size_t_size:
  *	This symbol holds the size of a Size_t in bytes.
Index: gnu/usr.bin/perl/plan9/config_sh.sample
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/plan9/config_sh.sample,v
retrieving revision 1.9
diff -u -p -u -p -r1.9 config_sh.sample
--- gnu/usr.bin/perl/plan9/config_sh.sample	13 Feb 2019 21:15:28 -0000	1.9
+++ gnu/usr.bin/perl/plan9/config_sh.sample	13 May 2019 15:13:25 -0000
@@ -35,8 +35,8 @@ api_subversion='0'
 api_version='28'
 api_versionstring='5.28.0'
 ar='ar'
-archlib='/sys/lib/perl5/5.28.1/386'
-archlibexp='/sys/lib/perl5/5.28.1/386'
+archlib='/sys/lib/perl5/5.28.2/386'
+archlibexp='/sys/lib/perl5/5.28.2/386'
 archname64=''
 archname='386'
 archobjs=''
@@ -812,17 +812,17 @@ inc_version_list=' '
 inc_version_list_init='0'
 incpath=''
 inews=''
-installarchlib='/sys/lib/perl/5.28.1/386'
+installarchlib='/sys/lib/perl/5.28.2/386'
 installbin='/usr/bin'
 installman1dir='/sys/man/1pub'
 installman3dir='/sys/man/2pub'
 installprefix='/usr'
 installprefixexp='/usr'
-installprivlib='/sys/lib/perl/5.28.1'
+installprivlib='/sys/lib/perl/5.28.2'
 installscript='/usr/bin'
-installsitearch='/sys/lib/perl/5.28.1/site_perl/386'
+installsitearch='/sys/lib/perl/5.28.2/site_perl/386'
 installsitebin='/usr/bin'
-installsitelib='/sys/lib/perl/5.28.1/site_perl'
+installsitelib='/sys/lib/perl/5.28.2/site_perl'
 installstyle='lib/perl5'
 installusrbinperl='undef'
 installvendorarch=''
@@ -947,8 +947,8 @@ pmake=''
 pr=''
 prefix='/usr'
 prefixexp='/usr'
-privlib='/sys/lib/perl/5.28.1'
-privlibexp='/sys/lib/perl/5.28.1'
+privlib='/sys/lib/perl/5.28.2'
+privlibexp='/sys/lib/perl/5.28.2'
 procselfexe=''
 prototype='define'
 ptrsize='4'
@@ -1013,13 +1013,13 @@ sig_num='0 1 2 3 4 5 6 7 8 9 10 11 12 13
 sig_num_init='0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 0'
 sig_size='50'
 signal_t='void'
-sitearch='/sys/lib/perl/5.28.1/site_perl/386'
+sitearch='/sys/lib/perl/5.28.2/site_perl/386'
 sitearchexp='/sys/lib/perl/site_perl/386'
 sitebin='/usr/bin'
 sitebinexp='/usr/bin'
-sitelib='/sys/lib/perl/5.28.1/site_perl'
-sitelib_stem='/sys/lib/perl/5.28.1/site_perl'
-sitelibexp='/sys/lib/perl/5.28.1/site_perl'
+sitelib='/sys/lib/perl/5.28.2/site_perl'
+sitelib_stem='/sys/lib/perl/5.28.2/site_perl'
+sitelibexp='/sys/lib/perl/5.28.2/site_perl'
 siteprefix='/usr'
 siteprefixexp='/usr'
 sizesize='4'
@@ -1052,7 +1052,7 @@ stdio_stream_array=''
 strerror_r_proto='0'
 strings='/sys/include/ape/string.h'
 submit=''
-subversion='1'
+subversion='2'
 sysman='/sys/man/1pub'
 tail=''
 tar=''
@@ -1133,8 +1133,8 @@ vendorlib_stem=''
 vendorlibexp=''
 vendorprefix=''
 vendorprefixexp=''
-version='5.28.1'
-version_patchlevel_string='version 28 subversion 1'
+version='5.28.2'
+version_patchlevel_string='version 28 subversion 2'
 versiononly='undef'
 vi=''
 xlibpth=''
@@ -1148,7 +1148,7 @@ config_args=''
 config_argc=0
 PERL_REVISION=5
 PERL_VERSION=28
-PERL_SUBVERSION=1
+PERL_SUBVERSION=2
 PERL_API_REVISION=5
 PERL_API_VERSION=28
 PERL_API_SUBVERSION=0
Index: gnu/usr.bin/perl/pod/perl.pod
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/pod/perl.pod,v
retrieving revision 1.29
diff -u -p -u -p -r1.29 perl.pod
--- gnu/usr.bin/perl/pod/perl.pod	13 Feb 2019 21:18:39 -0000	1.29
+++ gnu/usr.bin/perl/pod/perl.pod	13 May 2019 15:13:25 -0000
@@ -181,7 +181,9 @@ aux h2ph h2xs perlbug pl2pm pod2html pod
 
     perlhist		Perl history records
     perldelta		Perl changes since previous version
+    perl5281delta	Perl changes in version 5.28.1
     perl5280delta	Perl changes in version 5.28.0
+    perl5263delta	Perl changes in version 5.26.3
     perl5262delta	Perl changes in version 5.26.2
     perl5261delta	Perl changes in version 5.26.1
     perl5260delta	Perl changes in version 5.26.0
Index: gnu/usr.bin/perl/pod/perl5263delta.pod
===================================================================
RCS file: gnu/usr.bin/perl/pod/perl5263delta.pod
diff -N gnu/usr.bin/perl/pod/perl5263delta.pod
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gnu/usr.bin/perl/pod/perl5263delta.pod	13 May 2019 15:13:25 -0000
@@ -0,0 +1,201 @@
+=encoding utf8
+
+=head1 NAME
+
+perl5263delta - what is new for perl v5.26.3
+
+=head1 DESCRIPTION
+
+This document describes differences between the 5.26.2 release and the 5.26.3
+release.
+
+If you are upgrading from an earlier release such as 5.26.1, first read
+L<perl5262delta>, which describes differences between 5.26.1 and 5.26.2.
+
+=head1 Security
+
+=head2 [CVE-2018-12015] Directory traversal in module Archive::Tar
+
+By default, L<Archive::Tar> doesn't allow extracting files outside the current
+working directory.  However, this secure extraction mode could be bypassed by
+putting a symlink and a regular file with the same name into the tar file.
+
+L<[perl #133250]|https://rt.perl.org/Ticket/Display.html?id=133250>
+L<[cpan #125523]|https://rt.cpan.org/Ticket/Display.html?id=125523>
+
+=head2 [CVE-2018-18311] Integer overflow leading to buffer overflow and segmentation fault
+
+Integer arithmetic in C<Perl_my_setenv()> could wrap when the combined length
+of the environment variable name and value exceeded around 0x7fffffff.  This
+could lead to writing beyond the end of an allocated buffer with attacker
+supplied data.
+
+L<[perl #133204]|https://rt.perl.org/Ticket/Display.html?id=133204>
+
+=head2 [CVE-2018-18312] Heap-buffer-overflow write in S_regatom (regcomp.c)
+
+A crafted regular expression could cause heap-buffer-overflow write during
+compilation, potentially allowing arbitrary code execution.
+
+L<[perl #133423]|https://rt.perl.org/Ticket/Display.html?id=133423>
+
+=head2 [CVE-2018-18313] Heap-buffer-overflow read in S_grok_bslash_N (regcomp.c)
+
+A crafted regular expression could cause heap-buffer-overflow read during
+compilation, potentially leading to sensitive information being leaked.
+
+L<[perl #133192]|https://rt.perl.org/Ticket/Display.html?id=133192>
+
+=head2 [CVE-2018-18314] Heap-buffer-overflow write in S_regatom (regcomp.c)
+
+A crafted regular expression could cause heap-buffer-overflow write during
+compilation, potentially allowing arbitrary code execution.
+
+L<[perl #131649]|https://rt.perl.org/Ticket/Display.html?id=131649>
+
+=head1 Incompatible Changes
+
+There are no changes intentionally incompatible with 5.26.2.  If any exist,
+they are bugs, and we request that you submit a report.  See
+L</Reporting Bugs> below.
+
+=head1 Modules and Pragmata
+
+=head2 Updated Modules and Pragmata
+
+=over 4
+
+=item *
+
+L<Archive::Tar> has been upgraded from version 2.24 to 2.24_01.
+
+=item *
+
+L<Module::CoreList> has been upgraded from version 5.20180414_26 to 5.20181129_26.
+
+=back
+
+=head1 Diagnostics
+
+The following additions or changes have been made to diagnostic output,
+including warnings and fatal error messages.  For the complete list of
+diagnostic messages, see L<perldiag>.
+
+=head2 New Diagnostics
+
+=head3 New Errors
+
+=over 4
+
+=item *
+
+L<Unexpected ']' with no following ')' in (?[... in regex; marked by E<lt>-- HERE in mE<sol>%sE<sol>|perldiag/"Unexpected ']' with no following ')' in (?[... in regex; marked by E<lt>-- HERE in mE<sol>%sE<sol>">
+
+(F) While parsing an extended character class a ']' character was encountered
+at a point in the definition where the only legal use of ']' is to close the
+character class definition as part of a '])', you may have forgotten the close
+paren, or otherwise confused the parser.
+
+=item *
+
+L<Expecting close paren for nested extended charclass in regex; marked by E<lt>-- HERE in mE<sol>%sE<sol>|perldiag/"Expecting close paren for nested extended charclass in regex; marked by E<lt>-- HERE in mE<sol>%sE<sol>">
+
+(F) While parsing a nested extended character class like:
+
+    (?[ ... (?flags:(?[ ... ])) ... ])
+                             ^
+
+we expected to see a close paren ')' (marked by ^) but did not.
+
+=item *
+
+L<Expecting close paren for wrapper for nested extended charclass in regex; marked by E<lt>-- HERE in mE<sol>%sE<sol>|perldiag/"Expecting close paren for wrapper for nested extended charclass in regex; marked by E<lt>-- HERE in mE<sol>%sE<sol>">
+
+(F) While parsing a nested extended character class like:
+
+    (?[ ... (?flags:(?[ ... ])) ... ])
+                              ^
+
+we expected to see a close paren ')' (marked by ^) but did not.
+
+=back
+
+=head2 Changes to Existing Diagnostics
+
+=over 4
+
+=item *
+
+L<Syntax error in (?[...]) in regex; marked by E<lt>-- HERE in mE<sol>%sE<sol>|perldiag/"Syntax error in (?[...]) in regex; marked by E<lt>-- HERE in mE<sol>%sE<sol>">
+
+This fatal error message has been slightly expanded (from "Syntax error in
+(?[...]) in regex mE<sol>%sE<sol>") for greater clarity.
+
+=back
+
+=head1 Acknowledgements
+
+Perl 5.26.3 represents approximately 8 months of development since Perl 5.26.2
+and contains approximately 4,500 lines of changes across 51 files from 15
+authors.
+
+Excluding auto-generated files, documentation and release tools, there were
+approximately 770 lines of changes to 10 .pm, .t, .c and .h files.
+
+Perl continues to flourish into its third decade thanks to a vibrant community
+of users and developers.  The following people are known to have contributed
+the improvements that became Perl 5.26.3:
+
+Aaron Crane, Abigail, Chris 'BinGOs' Williams, Dagfinn Ilmari Mannsåker, David
+Mitchell, H.Merijn Brand, James E Keenan, John SJ Anderson, Karen Etheridge,
+Karl Williamson, Sawyer X, Steve Hay, Todd Rinaldo, Tony Cook, Yves Orton.
+
+The list above is almost certainly incomplete as it is automatically generated
+from version control history.  In particular, it does not include the names of
+the (very much appreciated) contributors who reported issues to the Perl bug
+tracker.
+
+Many of the changes included in this version originated in the CPAN modules
+included in Perl's core.  We're grateful to the entire CPAN community for
+helping Perl to flourish.
+
+For a more complete list of all of Perl's historical contributors, please see
+the F<AUTHORS> file in the Perl source distribution.
+
+=head1 Reporting Bugs
+
+If you find what you think is a bug, you might check the perl bug database
+at L<https://rt.perl.org/> .  There may also be information at
+L<http://www.perl.org/> , the Perl Home Page.
+
+If you believe you have an unreported bug, please run the L<perlbug> program
+included with your release.  Be sure to trim your bug down to a tiny but
+sufficient test case.  Your bug report, along with the output of C<perl -V>,
+will be sent off to perlbug@perl.org to be analysed by the Perl porting team.
+
+If the bug you are reporting has security implications which make it
+inappropriate to send to a publicly archived mailing list, then see
+L<perlsec/SECURITY VULNERABILITY CONTACT INFORMATION>
+for details of how to report the issue.
+
+=head1 Give Thanks
+
+If you wish to thank the Perl 5 Porters for the work we had done in Perl 5,
+you can do so by running the C<perlthanks> program:
+
+    perlthanks
+
+This will send an email to the Perl 5 Porters list with your show of thanks.
+
+=head1 SEE ALSO
+
+The F<Changes> file for an explanation of how to view exhaustive details on
+what changed.
+
+The F<INSTALL> file for how to build Perl.
+
+The F<README> file for general stuff.
+
+The F<Artistic> and F<Copying> files for copyright information.
+
+=cut
Index: gnu/usr.bin/perl/pod/perl5281delta.pod
===================================================================
RCS file: gnu/usr.bin/perl/pod/perl5281delta.pod
diff -N gnu/usr.bin/perl/pod/perl5281delta.pod
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gnu/usr.bin/perl/pod/perl5281delta.pod	13 May 2019 15:13:25 -0000
@@ -0,0 +1,141 @@
+=encoding utf8
+
+=head1 NAME
+
+perl5281delta - what is new for perl v5.28.1
+
+=head1 DESCRIPTION
+
+This document describes differences between the 5.28.0 release and the 5.28.1
+release.
+
+If you are upgrading from an earlier release such as 5.26.0, first read
+L<perl5280delta>, which describes differences between 5.26.0 and 5.28.0.
+
+=head1 Security
+
+=head2 [CVE-2018-18311] Integer overflow leading to buffer overflow and segmentation fault
+
+Integer arithmetic in C<Perl_my_setenv()> could wrap when the combined length
+of the environment variable name and value exceeded around 0x7fffffff.  This
+could lead to writing beyond the end of an allocated buffer with attacker
+supplied data.
+
+L<[perl #133204]|https://rt.perl.org/Ticket/Display.html?id=133204>
+
+=head2 [CVE-2018-18312] Heap-buffer-overflow write in S_regatom (regcomp.c)
+
+A crafted regular expression could cause heap-buffer-overflow write during
+compilation, potentially allowing arbitrary code execution.
+
+L<[perl #133423]|https://rt.perl.org/Ticket/Display.html?id=133423>
+
+=head1 Incompatible Changes
+
+There are no changes intentionally incompatible with 5.28.0.  If any exist,
+they are bugs, and we request that you submit a report.  See
+L</Reporting Bugs> below.
+
+=head1 Modules and Pragmata
+
+=head2 Updated Modules and Pragmata
+
+=over 4
+
+=item *
+
+L<Module::CoreList> has been upgraded from version 5.20180622 to 5.20181129_28.
+
+=back
+
+=head1 Selected Bug Fixes
+
+=over 4
+
+=item *
+
+Perl 5.28 introduced an C<index()> optimization when comparing to -1 (or
+indirectly, e.g. >= 0).  When this optimization was triggered inside a C<when>
+clause it caused a warning ("Argument %s isn't numeric in smart match").  This
+has now been fixed.
+L<[perl #133368]|https://rt.perl.org/Ticket/Display.html?id=133368>
+
+=item *
+
+Matching of decimal digits in script runs, introduced in Perl 5.28, had a bug
+that led to C<"1\N{THAI DIGIT FIVE}"> matching C</^(*sr:\d+)$/> when it should
+not.  This has now been fixed.
+
+=item *
+
+The new in-place editing code no longer leaks directory handles.
+L<[perl #133314]|https://rt.perl.org/Ticket/Display.html?id=133314>
+
+=back
+
+=head1 Acknowledgements
+
+Perl 5.28.1 represents approximately 5 months of development since Perl 5.28.0
+and contains approximately 6,100 lines of changes across 44 files from 12
+authors.
+
+Excluding auto-generated files, documentation and release tools, there were
+approximately 700 lines of changes to 12 .pm, .t, .c and .h files.
+
+Perl continues to flourish into its fourth decade thanks to a vibrant community
+of users and developers.  The following people are known to have contributed
+the improvements that became Perl 5.28.1:
+
+Aaron Crane, Abigail, Chris 'BinGOs' Williams, Dagfinn Ilmari Mannsåker, David
+Mitchell, James E Keenan, John SJ Anderson, Karen Etheridge, Karl Williamson,
+Sawyer X, Steve Hay, Tony Cook.
+
+The list above is almost certainly incomplete as it is automatically generated
+from version control history.  In particular, it does not include the names of
+the (very much appreciated) contributors who reported issues to the Perl bug
+tracker.
+
+Many of the changes included in this version originated in the CPAN modules
+included in Perl's core.  We're grateful to the entire CPAN community for
+helping Perl to flourish.
+
+For a more complete list of all of Perl's historical contributors, please see
+the F<AUTHORS> file in the Perl source distribution.
+
+=head1 Reporting Bugs
+
+If you find what you think is a bug, you might check the perl bug database
+at L<https://rt.perl.org/> .  There may also be information at
+L<http://www.perl.org/> , the Perl Home Page.
+
+If you believe you have an unreported bug, please run the L<perlbug> program
+included with your release.  Be sure to trim your bug down to a tiny but
+sufficient test case.  Your bug report, along with the output of C<perl -V>,
+will be sent off to perlbug@perl.org to be analysed by the Perl porting team.
+
+If the bug you are reporting has security implications which make it
+inappropriate to send to a publicly archived mailing list, then see
+L<perlsec/SECURITY VULNERABILITY CONTACT INFORMATION>
+for details of how to report the issue.
+
+=head1 Give Thanks
+
+If you wish to thank the Perl 5 Porters for the work we had done in Perl 5,
+you can do so by running the C<perlthanks> program:
+
+    perlthanks
+
+This will send an email to the Perl 5 Porters list with your show of thanks.
+
+=head1 SEE ALSO
+
+The F<Changes> file for an explanation of how to view exhaustive details on
+what changed.
+
+The F<INSTALL> file for how to build Perl.
+
+The F<README> file for general stuff.
+
+The F<Artistic> and F<Copying> files for copyright information.
+
+=cut
Index: gnu/usr.bin/perl/pod/perldelta.pod
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/pod/perldelta.pod,v
retrieving revision 1.18
diff -u -p -u -p -r1.18 perldelta.pod
--- gnu/usr.bin/perl/pod/perldelta.pod	13 Feb 2019 21:15:28 -0000	1.18
+++ gnu/usr.bin/perl/pod/perldelta.pod	13 May 2019 15:13:25 -0000
@@ -2,49 +2,80 @@
 
 =head1 NAME
 
-perldelta - what is new for perl v5.28.1
+perldelta - what is new for perl v5.28.2
 
 =head1 DESCRIPTION
 
-This document describes differences between the 5.28.0 release and the 5.28.1
+This document describes differences between the 5.28.1 release and the 5.28.2
 release.
 
-If you are upgrading from an earlier release such as 5.26.0, first read
-L<perl5280delta>, which describes differences between 5.26.0 and 5.28.0.
+If you are upgrading from an earlier release such as 5.28.0, first read
+L<perl5281delta>, which describes differences between 5.28.0 and 5.28.1.
 
-=head1 Security
+=head1 Incompatible Changes
 
-=head2 [CVE-2018-18311] Integer overflow leading to buffer overflow and segmentation fault
+=head2 Any set of digits in the Common script are legal in a script run of
+another script
 
-Integer arithmetic in C<Perl_my_setenv()> could wrap when the combined length
-of the environment variable name and value exceeded around 0x7fffffff.  This
-could lead to writing beyond the end of an allocated buffer with attacker
-supplied data.
+There are several sets of digits in the Common script.  C<[0-9]> is the most
+familiar.  But there are also C<[\x{FF10}-\x{FF19}]> (FULLWIDTH DIGIT ZERO -
+FULLWIDTH DIGIT NINE), and several sets for use in mathematical notation, such
+as the MATHEMATICAL DOUBLE-STRUCK DIGITs.  Any of these sets should be able to
+appear in script runs of, say, Greek.  But the previous design overlooked all
+but the ASCII digits C<[0-9]>, so the design was flawed.  This has been fixed,
+so is both a bug fix and an incompatibility.
 
-L<[perl #133204]|https://rt.perl.org/Ticket/Display.html?id=133204>
+All digits in a run still have to come from the same set of ten digits.
 
-=head2 [CVE-2018-18312] Heap-buffer-overflow write in S_regatom (regcomp.c)
+L<[perl #133547]|https://rt.perl.org/Ticket/Display.html?id=133547>
 
-A crafted regular expression could cause heap-buffer-overflow write during
-compilation, potentially allowing arbitrary code execution.
+=head1 Modules and Pragmata
 
-L<[perl #133423]|https://rt.perl.org/Ticket/Display.html?id=133423>
+=head2 Updated Modules and Pragmata
 
-=head1 Incompatible Changes
+=over 4
 
-There are no changes intentionally incompatible with 5.28.0.  If any exist,
-they are bugs, and we request that you submit a report.  See
-L</Reporting Bugs> below.
+=item *
 
-=head1 Modules and Pragmata
+L<Module::CoreList> has been upgraded from version 5.20181129_28 to 5.20190419.
 
-=head2 Updated Modules and Pragmata
+=item *
 
-=over 4
+L<PerlIO::scalar> has been upgraded from version 0.29 to 0.30.
 
 =item *
 
-L<Module::CoreList> has been upgraded from version 5.20180622 to 5.20181129_28.
+L<Storable> has been upgraded from version 3.08 to 3.08_01.
+
+=back
+
+=head1 Platform Support
+
+=head2 Platform-Specific Notes
+
+=over 4
+
+=item Windows
+
+The Windows Server 2003 SP1 Platform SDK build, with its early x64 compiler and
+tools, was accidentally broken in Perl 5.27.9.  This has now been fixed.
+
+=item Mac OS X
+
+Perl's build and testing process on Mac OS X for C<-Duseshrplib> builds is now
+compatible with Mac OS X System Integrity Protection (SIP).
+
+SIP prevents binaries in F</bin> (and a few other places) being passed the
+C<DYLD_LIBRARY_PATH> environment variable.  For our purposes this prevents
+C<DYLD_LIBRARY_PATH> from being passed to the shell, which prevents that
+variable being passed to the testing or build process, so running C<perl>
+couldn't find F<libperl.dylib>.
+
+To work around that, the initial build of the F<perl> executable expects to
+find F<libperl.dylib> in the build directory, and the library path is then
+adjusted during installation to point to the installed library.
+
+L<[perl #126706]|https://rt.perl.org/Ticket/Display.html?id=126706>
 
 =back
 
@@ -54,41 +85,68 @@ L<Module::CoreList> has been upgraded fr
 
 =item *
 
-Perl 5.28 introduced an C<index()> optimization when comparing to -1 (or
-indirectly, e.g. >= 0).  When this optimization was triggered inside a C<when>
-clause it caused a warning ("Argument %s isn't numeric in smart match").  This
-has now been fixed.
-L<[perl #133368]|https://rt.perl.org/Ticket/Display.html?id=133368>
+If an in-place edit is still in progress during global destruction and the
+process exit code (as stored in C<$?>) is zero, perl will now treat the
+in-place edit as successful, replacing the input file with any output produced.
+
+This allows code like:
+
+  perl -i -ne 'print "Foo"; last'
+
+to replace the input file, while code like:
+
+  perl -i -ne 'print "Foo"; die'
+
+will not.  Partly resolves [perl #133659].
+
+L<[perl #133659]|https://rt.perl.org/Ticket/Display.html?id=133659>
 
 =item *
 
-Matching of decimal digits in script runs, introduced in Perl 5.28, had a bug
-that led to C<"1\N{THAI DIGIT FIVE}"> matching C</^(*sr:\d+)$/> when it should
-not.  This has now been fixed.
+A regression in Perl 5.28 caused the following code to fail
+
+ close(STDIN); open(CHILD, "|wc -l")'
+
+because the child's stdin would be closed on exec.  This has now been fixed.
+
+=item *
+
+C<pack "u", "invalid uuencoding"> now properly NUL terminates the zero-length
+SV produced.
+
+L<[perl #132655]|https://rt.perl.org/Ticket/Display.html?id=132655>
+
+=item *
+
+Failing to compile a format now aborts compilation.  Like other errors in
+sub-parses this could leave the parser in a strange state, possibly crashing
+perl if compilation continued.
+
+L<[perl #132158]|https://rt.perl.org/Ticket/Display.html?id=132158>
 
 =item *
 
-The new in-place editing code no longer leaks directory handles.
-L<[perl #133314]|https://rt.perl.org/Ticket/Display.html?id=133314>
+See L</Any set of digits in the Common script are legal in a script run of
+another script>.
 
 =back
 
 =head1 Acknowledgements
 
-Perl 5.28.1 represents approximately 5 months of development since Perl 5.28.0
-and contains approximately 6,100 lines of changes across 44 files from 12
+Perl 5.28.2 represents approximately 4 months of development since Perl 5.28.1
+and contains approximately 2,500 lines of changes across 75 files from 13
 authors.
 
 Excluding auto-generated files, documentation and release tools, there were
-approximately 700 lines of changes to 12 .pm, .t, .c and .h files.
+approximately 1,200 lines of changes to 29 .pm, .t, .c and .h files.
 
 Perl continues to flourish into its fourth decade thanks to a vibrant community
 of users and developers.  The following people are known to have contributed
-the improvements that became Perl 5.28.1:
+the improvements that became Perl 5.28.2:
 
-Aaron Crane, Abigail, Chris 'BinGOs' Williams, Dagfinn Ilmari Mannsåker, David
-Mitchell, James E Keenan, John SJ Anderson, Karen Etheridge, Karl Williamson,
-Sawyer X, Steve Hay, Tony Cook.
+Aaron Crane, Abigail, Andy Dougherty, David Mitchell, Karen Etheridge, Karl
+Williamson, Leon Timmermans, Nicolas R., Sawyer X, Steve Hay, Tina Müller,
+Tony Cook, Zak B. Elep.
 
 The list above is almost certainly incomplete as it is automatically generated
 from version control history.  In particular, it does not include the names of
Index: gnu/usr.bin/perl/pod/perldiag.pod
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/pod/perldiag.pod,v
retrieving revision 1.22
diff -u -p -u -p -r1.22 perldiag.pod
--- gnu/usr.bin/perl/pod/perldiag.pod	13 Feb 2019 21:15:28 -0000	1.22
+++ gnu/usr.bin/perl/pod/perldiag.pod	13 May 2019 15:13:25 -0000
@@ -733,9 +733,9 @@ keep a reference count on its arguments 
 do so.  Such arrays are not even supposed to be accessible to
 Perl code, but are only used internally.
 
-=item Cannot yet reorder sv_catpvfn() arguments from va_list
+=item Cannot yet reorder sv_vcatpvfn() arguments from va_list
 
-(F) Some XS code tried to use C<sv_catpvfn()> or a related function with a
+(F) Some XS code tried to use C<sv_vcatpvfn()> or a related function with a
 format string that specifies explicit indexes for some of the elements, and
 using a C-style variable-argument list (a C<va_list>).  This is not currently
 supported.  XS authors wanting to do this must instead construct a C array
Index: gnu/usr.bin/perl/pod/perlhist.pod
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/pod/perlhist.pod,v
retrieving revision 1.22
diff -u -p -u -p -r1.22 perlhist.pod
--- gnu/usr.bin/perl/pod/perlhist.pod	13 Feb 2019 21:15:29 -0000	1.22
+++ gnu/usr.bin/perl/pod/perlhist.pod	13 May 2019 15:13:25 -0000
@@ -34,7 +34,7 @@ Chris C<BinGOs> Williams, Zefram, Ævar 
 Little, Dave Rolsky, Max Maischein, Abigail, Jesse Luehrs, Tony Cook,
 Dominic Hargreaves, Aaron Crane, Aristotle Pagaltzis, Matthew Horsfall,
 Peter Martini, Sawyer X, Chad 'Exodist' Granum, Renee Bäcker, Eric Herman,
-John SJ Anderson, and Karen Etheridge.
+John SJ Anderson, Karen Etheridge, and Zak B. Elep.
 
 =head2 PUMPKIN?
 
@@ -651,11 +651,19 @@ the strings?).
  Sawyer X  5.28.0       2018-Jun-22
  Steve     5.28.1-RC1   2018-Nov-08
  Steve     5.28.1       2018-Nov-29
+ Steve     5.28.2-RC1   2019-Apr-05
+ Steve     5.28.2       2019-Apr-19
 
  Sawyer X  5.29.0       2018-Jun-26     The 5.29 development track
  Steve     5.29.1       2018-Jul-20
  BinGOs    5.29.2       2018-Aug-20
- John      5.29.3       2019-Sep-20
+ John      5.29.3       2018-Sep-20
+ Aaron     5.29.4       2018-Oct-20
+ Ether     5.29.5       2018-Nov-20
+ Abigail   5.29.6       2018-Dec-18
+ Abigail   5.29.7       2019-Jan-20
+ Nicolas R 5.29.8       2019-Feb-20
+ Zak Elep  5.29.9       2019-Mar-20
 
 =head2 SELECTED RELEASE SIZES
 
Index: gnu/usr.bin/perl/pod/perlre.pod
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/pod/perlre.pod,v
retrieving revision 1.20
diff -u -p -u -p -r1.20 perlre.pod
--- gnu/usr.bin/perl/pod/perlre.pod	13 Feb 2019 21:15:29 -0000	1.20
+++ gnu/usr.bin/perl/pod/perlre.pod	13 May 2019 15:13:25 -0000
@@ -2529,15 +2529,12 @@ characters from their native scripts and
 Unicode's UTS 39 (L<http://unicode.org/reports/tr39/>) Unicode Security
 Mechanisms in allowing such mixtures.
 
-The rules used for matching decimal digits are somewhat different.  Many
+The rules used for matching decimal digits are slightly stricter.  Many
 scripts have their own sets of digits equivalent to the Western C<0>
 through C<9> ones.  A few, such as Arabic, have more than one set.  For
 a string to be considered a script run, all digits in it must come from
-the same set, as determined by the first digit encountered. The ASCII
-C<[0-9]> are accepted as being in any script, even those that have their
-own set.  This is because these are often used in commerce even in such
-scripts.  But any mixing of the ASCII and other digits will cause the
-sequence to not be a script run, failing the match.  As an example,
+the same set of ten, as determined by the first digit encountered.
+As an example,
 
  qr/(*script_run: \d+ \b )/x
 
@@ -2558,11 +2555,11 @@ accent of some type.  These are consider
 master character, and so never cause a script run to not match.
 
 The other one is "Common".  This consists of mostly punctuation, emoji,
-and characters used in mathematics and music, and the ASCII digits C<0>
-through C<9>.  These characters can appear intermixed in text in many of
-the world's scripts.  These also don't cause a script run to not match,
-except any ASCII digits encountered have to obey the decimal digit rules
-described above.
+and characters used in mathematics and music, the ASCII digits C<0>
+through C<9>, and full-width forms of these digits.  These characters
+can appear intermixed in text in many of the world's scripts.  These
+also don't cause a script run to not match.  But like other scripts, all
+digits in a run must come from the same set of 10.
 
 This construct is non-capturing.  You can add parentheses to I<pattern>
 to capture, if desired.  You will have to do this if you plan to use
Index: gnu/usr.bin/perl/t/io/inplace.t
===================================================================
RCS file: /tmp/cvs/src/gnu/usr.bin/perl/t/io/inplace.t,v
retrieving revision 1.13
diff -u -p -u -p -r1.13 inplace.t
--- gnu/usr.bin/perl/t/io/inplace.t	5 Feb 2017 00:32:19 -0000	1.13
+++ gnu/usr.bin/perl/t/io/inplace.t	13 May 2019 15:13:25 -0000
@@ -5,7 +5,7 @@ require './test.pl';
 
 $^I = $^O eq 'VMS' ? '_bak' : '.bak';
 
-plan( tests => 6 );
+plan( tests => 8 );
 
 my @tfiles     = (tempfile(), tempfile(), tempfile());
 my @tfiles_bak = map "$_$^I", @tfiles;
@@ -90,4 +90,30 @@ SKIP:
     }
     
     END { unlink_all(@ifiles); }
+}
+
+{
+    my @tests =
+      ( # opts, code, result, name, $TODO
+       [ "-n", "die", "bar\n", "die shouldn't touch file" ],
+       [ "-n", "last", "", "last should update file" ],
+      );
+    our $file = tempfile() ;
+
+    for my $test (@tests) {
+        (my ($opts, $code, $result, $name), our $TODO) = @$test;
+        open my $fh, ">", $file or die;
+        print $fh "bar\n";
+        close $fh;
+
+        runperl( prog => $code,
+                 switches => [ grep length, "-i", $opts ],
+                 args => [ $file ],
+                 stderr => 1, # discarded
+               );
+        open $fh, "<", $file or die;
+        my $data = do { local $/; <$fh>; };
+        close $fh;
+        is($data, $result, $name);
+    }
 }
